//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3D2D93040106.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3D2D93040106.cm

//## begin module%3D2D93040106.cp preserve=no
//## end module%3D2D93040106.cp

//## Module: AddTableComponent%3D2D93040106; Package body
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/AddTableComponent.cxx

//## begin module%3D2D93040106.additionalIncludes preserve=no
//## end module%3D2D93040106.additionalIncludes

//## begin module%3D2D93040106.includes preserve=yes
//## end module%3D2D93040106.includes

// TableComponent
#include <XSModel/Model/Component/TableComponent.h>
// ComponentBase
#include <XSModel/Model/Component/ComponentBase.h>
// AddTableComponent
#include <XSModel/Model/Component/AddTableComponent.h>


//## begin module%3D2D93040106.declarations preserve=no
//## end module%3D2D93040106.declarations

//## begin module%3D2D93040106.additionalDeclarations preserve=yes
#include <XSModel/Model/UniqueEnergy.h>
#include <XSUtil/Parse/XSparse.h>
#include <XSstreams.h>
#include <XSUtil/Error/Error.h>
#include <iostream>
#include <typeinfo>
//## end module%3D2D93040106.additionalDeclarations


// Class AddTableComponent 

AddTableComponent::AddTableComponent(const AddTableComponent &right)
  //## begin AddTableComponent::AddTableComponent%36C456CD6038_copy.hasinit preserve=yes
      : AddComponent(right), 
        m_tableFile(right.m_tableFile), 
        m_tableType(right.m_tableType),
        m_table(0)
  //## end AddTableComponent::AddTableComponent%36C456CD6038_copy.hasinit
  //## begin AddTableComponent::AddTableComponent%36C456CD6038_copy.initialization preserve=yes
  //## end AddTableComponent::AddTableComponent%36C456CD6038_copy.initialization
{
  //## begin AddTableComponent::AddTableComponent%36C456CD6038_copy.body preserve=yes
  if (right.m_table) m_table = right.m_table->clone(this);
  //## end AddTableComponent::AddTableComponent%36C456CD6038_copy.body
}

AddTableComponent::AddTableComponent (CGroupBase* p)
  //## begin AddTableComponent::AddTableComponent%37EFA56FCC68.hasinit preserve=yes
      : AddComponent(p), 
        m_tableFile(""), 
        m_tableType(""), 
        m_table(0)
  //## end AddTableComponent::AddTableComponent%37EFA56FCC68.hasinit
  //## begin AddTableComponent::AddTableComponent%37EFA56FCC68.initialization preserve=yes
  //## end AddTableComponent::AddTableComponent%37EFA56FCC68.initialization
{
  //## begin AddTableComponent::AddTableComponent%37EFA56FCC68.body preserve=yes
  //## end AddTableComponent::AddTableComponent%37EFA56FCC68.body
}


AddTableComponent::~AddTableComponent()
{
  //## begin AddTableComponent::~AddTableComponent%36C456CD6038_dest.body preserve=yes
  delete m_table;
  //## end AddTableComponent::~AddTableComponent%36C456CD6038_dest.body
}



//## Other Operations (implementation)
void AddTableComponent::swap (Component& right)
{
  //## begin AddTableComponent::swap%3761395EE8D8.body preserve=yes
  AddComponent::swap(right);
  AddTableComponent& that = static_cast<AddTableComponent&>(right);
  std::swap(m_tableFile,that.m_tableFile);
  std::swap(m_tableType,that.m_tableType);
  std::swap(m_table,that.m_table);        
  //## end AddTableComponent::swap%3761395EE8D8.body
}

int AddTableComponent::read ()
{
  //## begin AddTableComponent::read%374D98CBF3BE.body preserve=yes

    string modelName = Component::currentModelName();
    XSparse::returnDelimitedArgument(modelName," {");
    m_tableFile = XSparse::returnDelimitedArgument(modelName,"}");
    m_table = TableComponent::returnTable(m_tableFile);
    m_table->filename(m_tableFile);
    
    bool readNow(true);

    m_table->read(readNow,this);
    name(m_table->name());
    const std::vector<Parameter*>& tableParams = m_table->parameters();
    componentBase()->parameterSet().reserve(tableParams.size());
    std::vector<Parameter*>::const_iterator p = tableParams.begin();
    std::vector<Parameter*>::const_iterator pEnd = tableParams.end();
    while ( p != pEnd )
    {
            (*p)->setParent(componentBase());
            (*p)->index(componentBase()->incrementModelParameterCount());
            parameterSet().push_back(*p);
            ++p;
    }
    addParam("norm");
    componentBase()->numParams(tableParams.size()+1);
    normParNum(componentBase()->numParams());
    
    return 0;
  //## end AddTableComponent::read%374D98CBF3BE.body
}

void AddTableComponent::calculate (bool saveComponentFlux, bool frozen)
{
  //## begin AddTableComponent::calculate%3A8BEC940157.body preserve=yes
  
  if (saveComponentFlux) saveUniquePhotonArray(saveComponentFlux);
                  
  const std::vector<Parameter *>& parameterSet = componentBase()->parameterSet();
  size_t  numParams = parameterSet.size();
  RealArray  startValues(numParams);
  
  bool proceed = true;
  if (frozen)
  {
        // if the 'frozen' flag is set, only compute this component if
        // the normalization is either frozen or linked only to frozen.
        size_t j = 0;
        Parameter* normalization = 0;
        while ( j < numParams )
        {
                if (parameterSet[j]->name() == "norm")
                {
                        normalization = parameterSet[j];
                        break;
                }  
                ++j;
               
        }
        if (!normalization->isFrozen() && !Parameter::isLinkedToFrozen(normalization)) 
                        proceed = false;
  }
  
  
  if (proceed)
  {
          // this flag is true for additive models - it means accumulate the
          // total flux in the energy bins as defined by uniqueEng. The converse
          // is where we want to "interpolate" the model, producing an array which
          // is scaled to the bin width - for multiplicative models.
          const static bool rebinSpectrum(true);
          const std::set<UniqueEnergy*>& energies = getUniqueEnergies();
          std::set<UniqueEnergy*>::const_iterator en   = energies.begin();
          std::set<UniqueEnergy*>::const_iterator enEnd = energies.end();
          
          while (en != enEnd)
          {
                const UniqueEnergy* uniqueEng = *en;
                const RealArray& energy = uniqueEng->energy();
                uniquePhotonArray(uniqueEng).resize(energy.size()-1);
                if ( m_table->isError()) 
                {
                        error(true);
                        uniquePhotonErrArray(uniqueEng).resize(energy.size()-1);
                }
                else
                {
                        uniquePhotonErrArray(uniqueEng).resize(0);       
                }
                m_table->interpolate(uniqueEng,uniquePhotonArray(uniqueEng),
                                                      uniquePhotonErrArray(uniqueEng),rebinSpectrum);
                
                // time dilation. Check for a redshift parameter and apply redshifts to
                // the energy and variance array.
  
                XSutility::MatchPtrName<Parameter> matchName;
                const std::vector<Parameter *>& parameterSet = componentBase()->parameterSet();
                                
                std::vector<Parameter*>::const_iterator r =
                        find_if(parameterSet.begin(),parameterSet.end(),bind2nd(matchName,"z"));
           
                Real z (0);      
                if ( r != parameterSet.end() ) z = (*r)->value();

                if ( z > 0 ) 
                {
                        Real zf (1/(1+z));
                        uniquePhotonArray(uniqueEng) *= zf;
                        uniquePhotonErrArray(uniqueEng) *= zf*zf;
                }

                // output arrays if in debug mode (harmlessly returns if log chatter
                // is < 30)
                
                debugPrint(tcout,"\nModel Output AddTableComponent::calculate() -");
                ++en;
           }
           
           


  }  
  else
  {
          const std::set<UniqueEnergy*>& energies = getUniqueEnergies();
          std::set<UniqueEnergy*>::const_iterator en   = energies.begin();
          std::set<UniqueEnergy*>::const_iterator enEnd = energies.end();
          while (en != enEnd)
          {
                uniquePhotonArray(*en).resize(0);
                uniquePhotonErrArray(*en).resize(0);
                ++en;
          }
  }
  //## end AddTableComponent::calculate%3A8BEC940157.body
}

void AddTableComponent::copy (const Component& right)
{
  //## begin AddTableComponent::copy%3A953E4603B5.body preserve=yes
  if ( typeid(*this) != typeid(right) ) 
          throw RedAlert("*** Programmer Error: copying to wrong type ***");  
  AddTableComponent __temp(static_cast<const AddTableComponent&>(right));
  swap(__temp);   
  //## end AddTableComponent::copy%3A953E4603B5.body
}

AddTableComponent* AddTableComponent::clone (CGroupBase* p) const
{
  //## begin AddTableComponent::clone%3AB785AB02C4.body preserve=yes
  AddTableComponent* cloned = new AddTableComponent(*this);
  cloned->setParent(p);
  return cloned;    
  //## end AddTableComponent::clone%3AB785AB02C4.body
}

void AddTableComponent::clearArrays (const std::set<UniqueEnergy*>& currentEngs)
{
  //## begin AddTableComponent::clearArrays%3D7CF33A0163.body preserve=yes
  Component::clearArrays(currentEngs);
  m_table->clearArrays(currentEngs);
  //## end AddTableComponent::clearArrays%3D7CF33A0163.body
}

void AddTableComponent::initializeForFit ()
{
  //## begin AddTableComponent::initializeForFit%4593FF0001CE.body preserve=yes
   const std::set<UniqueEnergy*>& energies = getUniqueEnergies();
   std::set<UniqueEnergy*>::const_iterator itEng   = energies.begin();
   std::set<UniqueEnergy*>::const_iterator itEngEnd = energies.end();
   while (itEng != itEngEnd)
   {
      const UniqueEnergy* uniqueEng = *itEng;
      m_table->energyWeights(uniqueEng);
      ++itEng;
   }
  //## end AddTableComponent::initializeForFit%4593FF0001CE.body
}

// Additional Declarations
  //## begin AddTableComponent%36C456CD6038.declarations preserve=yes
  //## end AddTableComponent%36C456CD6038.declarations

//## begin module%3D2D93040106.epilog preserve=yes
//## end module%3D2D93040106.epilog
